/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "audioerror.h"
#include "i18n.h"

namespace Error {
	const char *AudioErrorMsg[] = {
		"bad configuration",
		"system call failed",
		"request not supported by device",
		"bad request",
		"generic error"
	};
}

Error::AudioError::AudioError
	(string s1, AudioErrorID id, string s2) throw()
{
	Error::setLocation(s1);
	Error::setMessage(string(_(AudioErrorMsg[id])) + " " + s2);
}

