/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _GUI_H_
#define _GUI_H_

#include <string>
#include "guierror.h"
#include "note.h"

namespace Interface {
	class Gui {
		public:
		virtual ~Gui();

		virtual void open() throw(Error::GuiError) = 0;
		virtual void close() throw(Error::GuiError) = 0;

		virtual void start() throw(Error::GuiError) = 0;
		virtual void stop() throw(Error::GuiError) = 0;

		virtual void pause() throw(Error::GuiError) = 0;
		virtual void resume() throw(Error::GuiError) = 0;

		virtual void delay(unsigned int) throw(Error::GuiError) = 0;

		virtual void display(const Tuner::Note &, bool = true) throw(Error::GuiError) = 0;
		virtual void display(const std::string &) throw(Error::GuiError) = 0;

		virtual void errorMsg(const std::string &) throw() = 0;
	};

	inline Gui::~Gui() { }
}

#endif

