/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _PRESET_H_
#define _PRESET_H_

#include <string>
#include <vector>
#include "midinote.h"

namespace Player {
	class Preset {
		public:
			Preset() throw();
			Preset(const std::string &, const std::vector<MidiNote> &) throw();
		//	Preset(const Preset &);
		//	~Preset();

		//const Preset &operator=(const Preset &);

		const std::string &readName() const throw();
		const MidiNote &operator[](int) const throw();

		private:
		std::string name;
		std::vector<MidiNote> strings;
	};

	inline Preset::Preset() throw() { }
	inline Preset::Preset(const std::string &s, const std::vector<MidiNote> &v)
		throw(): name(s), strings(v)
	{
	}

	inline const std::string &
	Preset::readName() const throw() { return name; }
	inline const MidiNote &
	Preset::operator[](int i) const throw() { return strings[i]; }
}

#endif

