/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 * _MUST_ be cleaned, is too much confused
 */

#ifndef _WINDOW_CLASS_H_
#define _WINDOW_CLASS_H_

#include <new>

namespace Tuner {
	class Window {
		public:
		enum WindowType {
			NONE,
			RECTANGULAR,
			HANNING,
			PARZEN,
			BARTLETT,
			HAMMING,
			BLACKMAN
		};
			Window(int, WindowType) throw(std::bad_alloc);
		       ~Window();

		void	reconfigure(int, WindowType) throw(std::bad_alloc);
		double 	operator[](int) throw();
		bool	operator!() throw();

		private:
			Window(const Window &);
		const Window &operator=(const Window &);

		void	init(int, WindowType) throw(std::bad_alloc);
		void	destroy() throw();

		double *winData;
		int size;
		WindowType type;
	};

	inline Window::Window(int n, WindowType t)
		throw(std::bad_alloc): size(-1)
	{ init(n, t); }
	inline Window::~Window() { destroy(); }
	inline void Window::reconfigure(int n, WindowType t)
		throw(std::bad_alloc)
	{ init(n, t); }
	inline double Window::operator[](int n) throw()
	{ return *(winData + n); }
	inline bool Window::operator!() throw()
	{ return type == RECTANGULAR || type == NONE; }
	inline void Window::destroy() throw() { delete []winData; }
}

#endif

